<?php if (!defined('PmWiki')) exit();
/**
 * functions.php
 * @author V.Krishn (vkrishn@insteps.net), Copyright 2010-2023
 * @note This file is part of Cookbook recipe "TxtDb" for PmWiki;
 * You can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the  Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version. @see pmwiki.php for full details.
 * @package txtdb
 */

// **********************************************************
// Some fuctions
// **********************************************************
  function txtdb_get_file_format($mypagename, $filePath="uploads/Content", $fileExt="txt") { #not implemented
    $fileFmt = "$filePath/$mypagename".".$_fileExt";
    return $fileFmt;
  }
  function txtdb_get_file_content($f) {
    if (file_exists($f)) {
      $_filecontent = file_get_contents($f);
      return $_filecontent;
    }
    return;
  }
  function txtdb_get_page($pagename) {
    if (PageExists($pagename)) {
      $page = RetrieveAuthPage($pagename,'read');
      return $page;
    }
    return false;
  }
  function txtdb_get_page_content($pagename) {
    $page = txtdb_get_page($pagename);
    if(isset($page['text'])) return trim(@$page['text']);
    return false;
  }

  function txtdb_get_txtdb_url($exturl) { #not implemented
    //if $ExtUrl has $ScriptUrl in it then return
  }

  function txtdbSetPageVar($var, $opts) {
    if( ! is_array($var)) return;
    global $FmtPV;
    foreach($var as $k => $v)  {
      if($opts['isOverWrite'] === '1') { $FmtPV["$".$k] = "'$v'"; } #default
      if($opts['isOverWrite'] === '0') if( ! isset($FmtPV['$'.$k])) { $FmtPV["$".$k] = "'$v'"; }
    }
  }


  function txtdbGetTable($dbpage, $dbname, $dbtable) {

    global $TxtDb;

    $pagefmt = txtdb_get_page_content($dbpage);
    if ( ! $pagefmt || $dbname == '' || $dbtable == '') return;

    $txtdbPat1 =
        "\\(:database\\s+?$dbname\\s*?:\\).*?\\(:dbtable\\s+?$dbtable\\s*?(.*?):\\)" .
        "(.*?)\\(:dbtableend:\\).*?\\(:databaseend:\\)";
    preg_match("/$txtdbPat1/si", $pagefmt, $matchB);

    if($matchB[2]) {
      $table['properties'] = $matchB[1];
      $table['data'] = $matchB[2];
      $TxtDb[$dbpage][$dbname][$dbtable]['properties'] = $matchB[1];
      return $table;
    }
    return false;

  }

  function txtdbGetTableFP($tbl, $dbtable_mode, $size=2) {

      $sizeMBs = $size * 1024 * 1024;
      //$fp = fopen("php://temp/maxmemory:$sizeMBs", $dbtable_mode);
      $fp = fopen("php://temp/maxmemory:$sizeMBs", 'r+');

      $args = ParseArgs($tbl['properties']);
      if(array_key_exists('format', $args) && strtolower($args['format']) === 'pmwiki') {

        $fptemp = fopen("php://temp/maxmemory:$sizeMBs", 'r+');
        $GLOBALS['CSCHAR'] = '||'; // Char which seperates the columns in the table file

        $tbl['data'] = preg_replace("/\\\\.*?\\s/", "##", $tbl['data']);
        fputs($fptemp, trim($tbl['data']));
        rewind($fptemp);

        while (!feof($fptemp)) {
          preg_match('/^\|\|(.*?)\|\|$/', fgets($fptemp), $m);
          if( empty($m) ) continue;
          $data = $m[1];
          if(trim($data)) {
            $s = array('!', '  ', '|| ', ' ||');
            $r = array('', '', '||', '||');
            $data = str_replace($s, $r, $data);
            $data = trim($data);
            fputs($fp, $data."\n");
          } else {
            $data = '||||||||||||'."\n"; //3rd line as required
            fputs($fp, $data);
          }
        }
        fclose($fptemp);
        rewind($fp);

      } else {

        $GLOBALS['CSCHAR'] = '#'; // Char which seperates the columns in the table file
        fputs($fp, trim($tbl['data']));
        rewind($fp);

      }
        //print '<pre>'; echo stream_get_contents($fp); print '</pre>';
        //print '<pre>'; print_r($tbl); print '</pre>';exit;

      if (!$fp) return 0;
      return $fp;
  }


  function txtdbUpdateTable($txtdbDSN, $updatedTbl='', $simulate=true) { # @todo

      if ( ! $updatedTbl ) return;

      static $d = 0;
      global $EnablePost, $ChangeSummary, $Now, $IsPagePosted;
      extract($txtdbDSN);

      $page = RetrieveAuthPage($dbpage,'read');
      //$page = RetrieveAuthPage($pagename, 'edit', false);
      if ( ! $page || $dbname == '' || $dbtable == '') return;
      //PCache($pagename, $page);
      $pagefmt = @$page['text'];

      $txtdbPat2 =
          "(\\(:database\\s+?$dbname\\s*?:\\).*?\\(:dbtable\\s+?$dbtable\\s*?:\\))" .
          "(.*?)(\\(:dbtableend:\\).*?\\(:databaseend:\\))";
      $repfmt = '$1'."\n".$updatedTbl."\n".'$3';
      $rep = preg_replace("/$txtdbPat2/si", $repfmt, $pagefmt, 1);

      //print '<pre>'; print_r($rep); print '</pre>'; exit;

      $new = $page;
      $new['text'] = $rep;
      $new['csum'] = $ChangeSummary;
      if ($ChangeSummary) $new["csum:$Now"] = $ChangeSummary;
      if ($d < 1) {
        $d++; Lock(2); $IsPagePosted = UpdatePage($pagename, $page, $new); Lock(0);
      }
      return $IsPagePosted;

  }

  function txtdb_make_html_header_link($href) {
    if (!$href) return;
    else {
      $htmlHeaderLink = "<link rel='stylesheet' href='$href' type='text/css' />";
      return $htmlHeaderLink;
    }
  }



## Initiate lib
  function txtdb_init_lib($Instance) {
    static $init_count;
    if($init_count < 1) {
    }
    $init_count++;
    return;
  }



// ****************************************



// **********************************************************

/**
 * Array Transpose.
 * @param array array to be transposed
 * @param string select key
 */
  function txtdb_array_transpose($array, $selectKey = false) {
      if (!is_array($array)) return false;
      $return = array();
      foreach($array as $key => $value) {
          if (!is_array($value)) return $array;
          if ($selectKey) {
              if (isset($value[$selectKey])) $return[] = $value[$selectKey];
          } else {
              foreach ($value as $key2 => $value2) {
                  $return[$key2][$key] = $value2;
              }
          }
      }
      return $return;
  }


/**
 * Set/Show debug.
 * @param int value for debug level
 */
// *******************************************************
  function TxtDbDebug($EnableTxtDbDebug=0) {
    global $TxtDb;
    if(1 === $EnableTxtDbDebug) {
      $txtdbDebugMsg = print_r($TxtDb['debug']['msg'], true);
    }
    if(2 === $EnableTxtDbDebug) {
      $txtdbDebugMsg = print_r($TxtDb, true);
    }
    return $txtdbDebugMsg;
  }
// *******************************************************


